
require 'open3'
require_relative 'command_button'
require_relative 'service_list'
require_relative 'system_service'

class ServiceControler
	attr_accessor :service  
	attr_accessor :start_bt 
	attr_accessor :stop_bt 
	attr_accessor :status_bt
  attr_accessor :restart_bt
	attr_accessor :txtv 
  attr_accessor :listv 
  @@cmd = "sudo systemctl"

	def initialize(txtv, listv)
		@txtv = txtv
		self.init_textv
		@listv = listv
		@start_bt = CommandButton.new("Start", self)
		@stop_bt = CommandButton.new("Stop",self)
		@status_bt = CommandButton.new("Status", self)
		@restart_bt = CommandButton.new("Restart", self)
		connect_list_sel_to_textv  
	end
	def init_textv
	  @txtv.text = "No service selected"
	end
	def connect_list_sel_to_textv
	  @listv.signal_connect_sel_changed(self)
	end
  def execute(action)
		if @service then
			@action_output, @action_call_status = Open3.capture2e("#@@cmd #{action.downcase}  #@service" )
            self.ui_update(action)            
		end
	end
  def ui_update(action) 
# (always) update textView buffer text    
        result_text = "#{action}: #{@service.descr} "
        result_text << "\n Result: #{@action_call_status}"
        result_text << "\n" + @action_output
        @txtv.text =  result_text
# update status info in the result list
        if action.downcase == 'status'
            @status_output = @action_output
        else  # not sure if this makes senses in case systemctl call would be non-blocking
              # but otherwise it makes
           @status_output, status_call_status = Open3.capture2e("#@@cmd status  #@service" )   
        end 
        @service.set_status_info_from_output( @status_output )    
        @listv.update_selected_row  
    end
end
